// lab5.cpp : My solution for lab 5
//

#include "stdafx.h"
#include <conio.h>
#include <iostream>
#include <fstream>
#include <string>
#include <list>
#include <math.h>
using namespace std;
enum Calltype {SALE,NOANSWER,REMOVE,TRYAGAIN};

class customer {
	public:
		customer() { lname = fname = phone = ""; callme = true; calls=0;}
		void setValues(string l, string f, string p)
		{
			lname = l; fname = f; phone = p;
			callme=true; calls = 0;
		} // setValues

		void print() {
			cout << lname << "," << fname << ": " << phone;
			cout << " called " << calls;
			if(callme) 
				cout << " Still on list" << endl;
			else
				cout << " removed from list" << endl;
		} // print

		void bumpCalls() { calls++;}
		void remove() { callme = false;}
		bool cancall() { return callme;}
	private:
		string fname;  // customers first name
		string lname;  // customers last name
		string phone;  // customers phone number
		bool callme;  // is true, ok to call;
		int calls;    // how many times did this one get called
}; // customer

class worklist {
	public:
		worklist() { calls = noans = sales = removes = 0;}
		void loadData(string file);   // read the file of customers in the list
		void runList();  // processing the list
		void summary();  // summary of sales results
		void details();  // customer by customer details
	private:
		Calltype callresult();
		list<customer> clist;
		string filename;  // what file contains the initial data
		int calls;  // how many people were called
		int noans;  // how many people didn't answer
		int sales;  // how many people bought something
		int removes; // how many asked to be removed
}; // worklist

// generate a number between o and 99 and return the
// code for what to do with the call
Calltype
worklist::callresult()
{
	int x = rand() % 100;
	if(x < 30) return NOANSWER;
	if(x < 40) return REMOVE;
	if(x < 60) return SALE;
	if(x < 100) return TRYAGAIN;
	return NOANSWER;  // just in case
} // callresult

void
worklist::loadData(string file)
{
	ifstream indata;
	customer C;
	string l,f,p;  // lname,fname,phone
	indata.open(file.c_str());

	if(!indata) {
		cerr << "file open of " << file << " failed" << endl;
		exit(1);
	}

	while(true) {
		indata >> l >> f >> p;	
		if(indata.eof()) break;  // no more data
		C.setValues(l,f,p);
		clist.push_back(C);
	} // file read
	indata.close();
	cout << "Data loaded from " << file << endl;

} // loadData

void
worklist::runList()
{
	list<customer>::iterator ptr;
	while(true) {
		int oldcalls = calls;  // used to tell if anybody called on this pass
		for(ptr = clist.begin(); ptr != clist.end(); ptr++) {
			if(!ptr->cancall()) continue;  // skip this person
			calls++;  // we made a call
			ptr->bumpCalls();  // we called this person
			switch(callresult()) {
				case SALE:
						sales++;  // we made a sale
						ptr->remove(); // mark them as off the list
						break;
				case NOANSWER:
						noans++;  // no answer
						break;
				case TRYAGAIN:
						// we don't do anything in this case, but it is 
						// good to have it here in case we change our minds later
						break;
				case REMOVE:
						ptr->remove(); // mark them as off the list
						removes++;  // person wants to ne left alone
						break;
				default :
						break;
			} // switch
		} // list loop
		// if calls == oldcalls, nobody was called and we should stop
		if(oldcalls == calls) break;
		
		// we keep calling people until at least once we
		// have handled every kind of call
		// The lab said > 0, I used 10 to make it run longer
		if((sales > 10) && (noans > 10 ) && (removes > 10) ) break;
	} // worklist processing
} // runList

void
worklist::summary()
{
	cout << "Summary of processing the list" << endl;
	cout << "There were " << clist.size() << " customers on the list" << endl;
	cout << "We made " << calls << " calls" << endl;
	cout << "There were " << noans << " calls not answered, " << sales << " sales";
	cout << " and " << removes << " customers removed" << endl;
} // summary

void
worklist::details()
{
	list<customer>::iterator ptr = clist.begin();
	cout << "Details by customer" << endl;
	while(ptr != clist.end()) {
		ptr->print();
		ptr++;
	} // while
} // details

int 
main(int argc, char* argv[])
{
	worklist W;

	W.loadData("lab5data.txt");
	W.runList();
	W.summary();
	cout << "hit any key to continue";
	char c = _getche();  cout << endl;
	W.details();

	return 0;
}
